#ifndef LIBCOWONILB_H
#define LIBCOWONILB_H

#include <inttypes.h>

struct ilb {
						 // File format description:
	char header[16];     // this must be "iAUDIO 160x128C\0" for cowon iaudio 7 (16gb)
	uint16_t unknown;    // changing this value seems to have no effect
	uint16_t numframes;  // my player seems to play only up to 48(?) frames TODO: make sure by printing numbers
						 // the rest of the file are numframes x 16bit timing info, time for frame in ms, followed by
						 // framewise rgb data in row major order, 3*8 bit per pixel, 160x128 pixels per frame
} __attribute__((__packed__));

typedef struct ilb CowonAnim;

CowonAnim* create_new_animation(unsigned int numframes, unsigned int default_time_per_frame);
void destroy_animation(CowonAnim* a);
int get_num_frames_in_animation(CowonAnim* a);
unsigned int get_time_for_frame(CowonAnim* a, unsigned int frame);
unsigned int set_time_for_frame(CowonAnim* a, unsigned int frame, unsigned int time_in_ms);
void write_animation_to_file(CowonAnim *a, char* filename);
CowonAnim* read_animation_from_file(char* filename);
void set_pixel(CowonAnim *a, unsigned int frame, unsigned int x, unsigned int y, unsigned char red, unsigned char green, unsigned char blue);
char* get_pixels(CowonAnim *a, unsigned int frame);
int get_width(CowonAnim* a);
int get_height(CowonAnim* a);

#endif
